<template>
  <q-page>
    <q-form 
    
    ref = "tawag"
    @submit = "submitForm()" class="q-ma-md">

    <h6 class="text-h6 text-left q-ma-none">
        Fillupan mo: </h6> 
      
    <q-input v-model="name" label="Name"
      class="q-pa-none col-10"
      lazy-rules
      :rules="[(val) => !!val || 'Field is required']" />
    <q-input v-model="username" label="Username"
      class="q-pa-none col-10"
      lazy-rules
      :rules="[(val) => !!val || 'Field is required']"/>
    <q-input v-model="email" label="Email"
      class="q-pa-none col-10"
      lazy-rules
      :rules="[(val) => !!val || 'Field is required']"/>
    <div>
    <h6 class="text-h6 text-left q-ma-none"> Address: </h6>
    <!-- <span>{{ address }}</span> -->
    <q-input v-model="address.street" label="Street"
      class="q-pa-none col-10"
      lazy-rules
      :rules="[(val) => !!val || 'Field is required']"/>
    <q-input v-model="address.suite" label="Suite"
      class="q-pa-none col-10"
      lazy-rules
      :rules="[(val) => !!val || 'Field is required']"/>
    <q-input v-model="address.city" label="City"
      class="q-pa-none col-10"
      lazy-rules
      :rules="[(val) => !!val || 'Field is required']"/>
    <q-input v-model="address.zipcode" label="zipcode"
      class="q-pa-none col-10"
      lazy-rules
      :rules="[(val) => !!val || 'Field is required']"/>
    <q-input v-model="address.geo.lat" label="Latitude"
      class="q-pa-none col-10"
      lazy-rules
      :rules="[(val) => !!val || 'Field is required']"/>
    <q-input v-model="address.geo.lng" label="Longitude"
      class="q-pa-none col-10"
      lazy-rules
      :rules="[(val) => !!val || 'Field is required']"/>
    </div>
    <h6 class="text-h6 text-left q-ma-none"> Other Info: </h6>
    <q-input v-model="phone" label="Cellphone Number"
      class="q-pa-none col-10"
      lazy-rules
      :rules="[(val) => !!val || 'Field is required']"/>
    <q-input v-model="website" label="Website"
      class="q-pa-none col-10"
      lazy-rules
      :rules="[(val) => !!val || 'Field is required']"/>
    <h6 class="text-h6 text-left q-ma-none"> Company: </h6>
    <q-input v-model="company.name" label="Company Name"
      class="q-pa-none col-10"
      lazy-rules
      :rules="[(val) => !!val || 'Field is required']"/>
    <q-input v-model="company.catchPhrase" label="Catch Phrase"
      class="q-pa-none col-10"
      lazy-rules
      :rules="[(val) => !!val || 'Field is required']"/>  
    <q-input v-model="company.bs" label="BS"
      class="q-pa-none col-10"
      lazy-rules
      :rules="[(val) => !!val || 'Field is required']"/>   
    
  <q-btn
    :loading = "btnLoadingState"
    style="margin-right: 10px"
    type="submit"
    label= "Submit"
    color="purple"
  />
  </q-form>

  <q-card class="bg-primary text-white q-pa-none flex justify-between items-center"
/>
    
  </q-page>
</template>
  
<script>
import { ref, computed } from 'vue';
import axios from 'axios';
import { AddUserPage, ListofUsers } from "../composables/Users";
import {rows} from "../pages/ListofUsers"
export default {
    setup () {
      const id = ref('');
      const name = ref('');
      const username = ref('');
      const email = ref('');
      const address = ref({
        street: '',
        suite: '',
        city: '',
        zipcode:'',
        geo: ref({
          lat: '',
          lng: '',
        })
      });
      const phone = ref('');
      const website = ref('');
      const company = ref({
        name: '',
        catchPhrase: '',
        bs: '',
      });

      const submitted = ref(false);
      let tawag = ref(null);
      let btnLoadingState = ref(false);

      const form = computed(() => ({
        id: id.value,
        name: name.value,
        username: username.value,
        email: email.value,
        address: address.value,
        phone: phone.value,
        website: website.value,
        company: company.value,
      }));

      const submitForm = () => {
          btnLoadingState.value = true;
          let incrementID = rows.value.length; 

          axios
          .post("https://jsonplaceholder.typicode.com/users", 
          form.value)
          .then((response) => {
            // console.log(response.data) ; 
            if (response.status === 201) {
              AddUserPage.value.id = ++incrementID;
              AddUserPage.value = response.data;

              // Adduserpage = empty
              // with unshift method (add data to the first row)
              // response data -> adduserpage
              // adduserpage = response data

              rows.value.unshift(AddUserPage.value);
              // rows.value.push(AddUserPage.value); yung push dito aay "add data to the last row"
              // rows.value = aduserpage = response
        


              // GOAL:
              // Adduserpage = response data
              // 
              console.log(AddUserPage.value) ;
              console.log(rows.value) ;
              // console.log(length)
              // id.value = AddUserPage.value.length +1;
          
              name.value = '';
              username.value = '';
              email.value = '';
              address.value ={
                street: '',
                suite: '',
                city: '',
                zipcode: '',
                geo: {
                  lat: '',
                  lng: '',
                },
              };
              phone.value = '';
              website.value = '';
              company.value ={
                name: '',
                catchPhrase: '',
                bs:''
              };
          
          }
          btnLoadingState.value = false;
          
        })
        tawag.value.reset();
      }

      // let toadd = ref(null);  

      // function submit() {
      //   console.log(AddUserPage.value)
      //   // btnLoadingState.value = true;
      //   submitted.value = true;
      //   AddUserPage.value.push({
      //     id: AddUserPage.value.length + 1,
      //     name: name.value,
      //     username: username.value,
      //     email: email.value,
      //     address: { ...address.value },
      //     phone: phone.value,
      //     website: website.value,
      //     company: { ...company.value },
      //   });
      //   ListofUsers.value.push(AddUserPage);
      //   name.value = '';
      //   username.value = '';
      //   email.value = '';
      //   address.value ={
      //     street: '',
      //     suite: '',
      //     city: '',
      //     zipcode: '',
      //     geo: {
      //       lat: '',
      //       lng: '',
      //     },
      //   };
      //   phone.value = '';
      //   website.value = '';
      //   company.value ={
      //     name: '',
      //     catchPhrase: '',
      //     bs:''
      //   };
        
      //   tawag.value.reset();
      // }


    return{
        // submit,
        submitForm,
        submitted,
        username,
        name,
        email,
        address,
        phone,
        website,
        company,
        id,
        btnLoadingState,
        tawag, 
        rows
    }
    }}
    





</script>

